<?php
/**
* Axaipay Prestashop Plugin
*
* @package Payment Method
* @author Axai Digital Team 
* //DS 1.0
*/

class AxaipayValidationModuleFrontController extends ModuleFrontController {
 public $display_column_left = false;
 public $display_column_right = false;
 public $ssl = true;
    
 /**
  * 
  * 
  * @see FrontController::postProcess()
  */
 public function postProcess()
 {
  $cart = $this->context->cart;
  if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active)
     Tools::redirect('index.php?controller=order&step=1');
  
  // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
  $authorized = false;
  foreach (Module::getPaymentModules() as $module)
   if ($module['name'] == 'axaipay')
   {
    $authorized = true;
    break;
   }
  if (!$authorized)
   die($this->module->l('This payment method is not available.', 'validation'));

  $customer = new Customer($cart->id_customer);
  if (!Validate::isLoadedObject($customer))
   Tools::redirect('index.php?controller=order&step=1');

  $merchant = $_POST['mchtId'];
  $cartid = substr($_POST['mchtTrxnId'], 10);
  $signature   = $_POST['signature'];
  $tranID  = $_POST['trxnId'];
  $paydate = $_POST['trxnTime'];
  $status  = $_POST['trxnStatus'];
  $amount  = $_POST['trxnAmount'];             
  $response = array();
  foreach( $_POST As $k => $v )
   $response[] = "[".$k."]=".$v;

  $url = Configuration::get('AXAIPAY_ENVIRONMENT');


  $PS_STATUS = Configuration::get('PS_OS_ERROR');
  if($status == "11") {
    $PS_STATUS = Configuration::get('PS_OS_PAYMENT');
  }
  elseif($status == "3")
   $PS_STATUS = Configuration::get('PS_OS_PREPARATION');
  else
   $PS_STATUS = Configuration::get('PS_OS_ERROR');
   
  $objOrder = new Order( (int)Order::getOrderByCartId($cartid) );
  if (Order::getOrderByCartId($cartid) === false )
  {
   $cart = new Cart($cartid);
   if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active)
    exit;
   
   // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
   $authorized = false;
   foreach (Module::getPaymentModules() as $module)
    if ($module['name'] == 'axaipay')
    {
     $authorized = true;
     break;
    }
   if (!$authorized)
    exit;

   $customer = new Customer($cart->id_customer);
   if (!Validate::isLoadedObject($customer))
    exit;

   $extra_vars['transaction_id'] = $tranID;
   $this->module->validateOrder($cartid, $PS_STATUS, $amount, $this->module->displayName, implode("\n ", $response), $extra_vars, (int)$currency->id, false, $customer->secure_key);
  }
  else
  {
   $current_state = $objOrder->current_state;

   if($current_state != 2)
   {
    $new_history = new OrderHistory();
    $new_history->id_order = (int)$objOrder->id;
    $new_history->changeIdOrderState($PS_STATUS, $objOrder, true);
    $new_history->addWithemail(true);
    
    $payment = $objOrder->getOrderPaymentCollection();
    if (isset($payment[0]))
    {
     $payment[0]->transaction_id = $tranID;
     $payment[0]->save();
    }
    
    $msg = new Message();
    $msg->message = ( (count($response) > 0)  ? implode("\n ", $response) : "Missing POST value" );
    $msg->id_cart = (int)$cartid;
    $msg->id_customer = (int)($objOrder->id_customer);
    $msg->id_order = (int)$objOrder->id;
    $msg->private = 1;
    $msg->add();
   }
  }
  Tools::redirect('index.php?controller=order-confirmation&id_cart='.$cartid.'&id_module='.$this->module->id.'&id_order='.$this->module->currentOrder.'&key='.$customer->secure_key);
 }
}